unit FR_T;

interface

uses Drivers, Objects, Views, Dialogs;

const
  cmRegisterNoClose     = 100;
  cmRegisterWithClose   = 101;
  cmReturnNoClose       = 102;
  cmReturnWithClose     = 103;
  cmCloseCheck          = 104;
  cmCloseCheck2         = 105;
  cmCloseCheck3         = 106;
  cmCloseCheck4         = 107;
  cmCloseCheckDelivery  = 108;
  cmCashInCome          = 109;
  cmCashOutCome         = 110;
  { ----- }
  cmAnnul               = 112;
  cmAnnulWithClose      = 113;
  cmCut                 = 114;
  cmOpenCashDrawer      = 115;
  cmStorno              = 116;
  cmDiscount            = 117;
  cmSummDiscount        = 118;
  cmPosDiscount         = 119;
  cmSummPosDiscount     = 120;
  cmCancelCheque        = 121;
  cmCancelDiscount      = 122;

type
  DataRec1 = record
    Name : String[24];
    NameEx : String[24];
    Price : String[11];
    Quantity : String[11];
    Percents : String[12];
    Summ : String[11];
    Department : String[2];
    CutMode    : String[1];
    ResultCode : String[3];
    end;
  PDataRec1 = ^DataRec1;

  { TCustomDialog }

  PCustomDialog = ^TCustomDialog;
  TCustomDialog = object(TDialog)
    constructor Init;
    constructor Load(var S: TStream);
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure Store(var S: TStream);
    function Valid(Command : word): boolean; virtual;
    destructor Done; virtual;
  end;

const
  RCustomDialog : TStreamRec = (
    ObjType: 12345;            {<--- Insert a unique number >= 100 here!!}
    VmtLink: Ofs(Typeof(TCustomDialog)^);
    Load : @TCustomDialog.Load;
    Store : @TCustomDialog.Store);

implementation

{ TCustomDialog }

constructor TCustomDialog.Init;
var
  R: TRect;
  Control : PView;
begin
R.Assign(0, 0, 80, 25);
inherited Init(R, '');
Flags := Flags or wfGrow or wfZoom;

R.Assign(2, 2, 19, 3);
Control := New(PStaticText, Init(R, ''));
Insert(Control);

R.Assign(2, 4, 19, 5);
Control := New(PStaticText, Init(R, '. '));
Insert(Control);

R.Assign(2, 6, 19, 7);
Control := New(PStaticText, Init(R, ' / 㬬'));
Insert(Control);

R.Assign(2, 8, 19, 9);
Control := New(PStaticText, Init(R, '⢮'));
Insert(Control);

R.Assign(2, 10, 19, 11);
Control := New(PStaticText, Init(R, ''));
Insert(Control);

R.Assign(2, 12, 19, 13);
Control := New(PStaticText, Init(R, ' '));
Insert(Control);

R.Assign(2, 14, 19, 15);
Control := New(PStaticText, Init(R, ' ᥪ樨'));
Insert(Control);

R.Assign(2, 16, 19, 17);
Control := New(PStaticText, Init(R, ' १'));
Insert(Control);

R.Assign(2, 22, 19, 23);
Control := New(PStaticText, Init(R, ''));
Insert(Control);

{ --- }

R.Assign(19, 2, 37, 3);
Control := New(PInputLine, Init(R, 24));
Insert(Control);

R.Assign(19, 4, 37, 5);
Control := New(PInputLine, Init(R, 24));
Insert(Control);

R.Assign(19, 6, 37, 7);
Control := New(PInputLine, Init(R, 11));
Insert(Control);

R.Assign(19, 8, 37, 9);
Control := New(PInputLine, Init(R, 11));
Insert(Control);

R.Assign(19, 10, 37, 11);
Control := New(PInputLine, Init(R, 12));
Insert(Control);

R.Assign(19, 12, 37, 13);
Control := New(PInputLine, Init(R, 11));
Insert(Control);

R.Assign(19, 14, 37, 15);
Control := New(PInputLine, Init(R, 2));
Insert(Control);

R.Assign(19, 16, 37, 17);
Control := New(PInputLine, Init(R, 1));
Insert(Control);

R.Assign(19, 22, 37, 23);
Control := New(PInputLine, Init(R, 3));
Insert(Control);

{ ------------- }

R.Assign(37, 2, 58, 4);
Control := New(PButton, Init(R, '',cmRegisterNoClose, bfDefault));
Insert(Control);
R.Assign(37, 4, 58, 6);
Control := New(PButton, Init(R, ' 2',cmRegisterWithClose, bfNormal));
Insert(Control);
R.Assign(37, 6, 58, 8);
Control := New(PButton, Init(R, '',cmReturnNoClose, bfNormal));
Insert(Control);
R.Assign(37, 8, 58, 10);
Control := New(PButton, Init(R, ' 2',cmReturnWithClose, bfNormal));
Insert(Control);
R.Assign(37, 10, 58, 12);
Control := New(PButton, Init(R, '⨥ 祪',cmCloseCheck, bfNormal));
Insert(Control);
R.Assign(37, 12, 58, 14);
Control := New(PButton, Init(R, '⨥ 祪 2',cmCloseCheck2, bfNormal));
Insert(Control);
R.Assign(37, 14, 58, 16);
Control := New(PButton, Init(R, '⨥ 祪 3',cmCloseCheck3, bfNormal));
Insert(Control);
R.Assign(37, 16, 58, 18);
Control := New(PButton, Init(R, '⨥ 祪 4',cmCloseCheck4, bfNormal));
Insert(Control);
R.Assign(37, 18, 58, 20);
Control := New(PButton, Init(R, '',cmCloseCheckDelivery, bfNormal));
Insert(Control);
R.Assign(37, 20, 58, 22);
Control := New(PButton, Init(R, 'ᥭ ',cmCashInCome, bfNormal));
Insert(Control);
R.Assign(37, 22, 58, 24);
Control := New(PButton, Init(R, '믫 ',cmCashOutCome, bfNormal));
Insert(Control);

{ ---- }

R.Assign(59, 2, 79, 4);
Control := New(PButton, Init(R, '㫨஢',cmAnnul, bfNormal));
Insert(Control);
R.Assign(59, 4, 79, 6);
Control := New(PButton, Init(R, '㫨஢ 2',cmAnnulWithClose, bfNormal));
Insert(Control);
R.Assign(59, 6, 79, 8);
Control := New(PButton, Init(R, '१ 祪',cmCut, bfNormal));
Insert(Control);
R.Assign(59, 8, 79, 10);
Control := New(PButton, Init(R, ' 騪',cmOpenCashDrawer, bfNormal));
Insert(Control);
R.Assign(59, 10, 79, 12);
Control := New(PButton, Init(R, '୮',cmStorno, bfNormal));
Insert(Control);
R.Assign(59, 12, 79, 14);
Control := New(PButton, Init(R, ' %',cmDiscount, bfNormal));
Insert(Control);
R.Assign(59, 14, 79, 16);
Control := New(PButton, Init(R, ' 㬬',cmSummDiscount, bfNormal));
Insert(Control);
R.Assign(59, 16, 79, 18);
Control := New(PButton, Init(R, ' 2 % ',cmPosDiscount, bfNormal));
Insert(Control);
R.Assign(59, 18, 79, 20);
Control := New(PButton, Init(R, ' 2 㬬',cmSummPosDiscount, bfNormal));
Insert(Control);
R.Assign(59, 20, 79, 22);
Control := New(PButton, Init(R, '⬥ 祪',cmCancelCheque, bfNormal));
Insert(Control);
R.Assign(59, 22, 79, 24);
Control := New(PButton, Init(R, '⬥ ᪨',cmCancelDiscount, bfNormal));
Insert(Control);

{
R.Assign(61, 20, 79, 22);
Control := New(PButton, Init(R, '', cmCancel, bfNormal));
Insert(Control); }

SelectNext(False);
end;

constructor TCustomDialog.Load(var S: TStream);
begin
inherited Load(S);
end;

procedure TCustomDialog.HandleEvent(var Event: TEvent);
begin
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

inherited HandleEvent(Event);
(*---
if Event.What = evMessage then
  case Event.Command of
    end;    --*)

end;

procedure TCustomDialog.Store(var S: TStream);
begin
inherited Store(S);
end;

function TCustomDialog.Valid(Command : word): boolean;
var
  Result : boolean;
begin
Result := inherited Valid(Command);
Valid := Result;
end;

destructor TCustomDialog.Done;
begin
inherited Done;
end;

end.
